cmake_minimum_required(VERSION 3.10)

project(checks-parser VERSION 0.1 LANGUAGES CXX)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC_SEARCH_PATHS Designer)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Widgets LinguistTools)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)
find_package(Qt5 COMPONENTS LinguistTools)

set(PROJECT_SOURCES
        main.cpp
        mainwindow.cpp
        mainwindow.h
        mainwindow.ui

        # Add other source files here that contain translatable strings
)

# Specify the UI files and source files for translation
set(TRANSLATION_SOURCES
        main.cpp
        mainwindow.cpp mainwindow.h mainwindow.ui
        outputdialog.cpp outputdialog.h outputdialog.ui
        settingsdialog.cpp settingsdialog.h settingsdialog.ui
        solvecaptchadialog.cpp solvecaptchadialog.h solvecaptchadialog.ui
        adjustpicturedialog.cpp adjustpicturedialog.h adjustpicturedialog.ui

        # Add other .cpp or .ui files that need translation here
)

if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    qt_add_executable(checks-parser
        MANUAL_FINALIZATION
        ${PROJECT_SOURCES}
    )

    # Generate translation files for Qt 6
    qt_add_translation(TRANSLATIONS "${TRANSLATION_SOURCES}")

else()
    if(ANDROID)
        add_library(checks-parser SHARED
            ${PROJECT_SOURCES}
        )

    else()
        # Generate translation files for Qt 5
        # QT5_ADD_TRANSLATION()
        qt5_create_translation(QM_FILES "${TRANSLATION_SOURCES}" translations/en_US.ts translations/ru_RU.ts)
        add_executable(checks-parser
            ${PROJECT_SOURCES}
            goods/goods.h goods/goods.cpp
            check/check.h check/check.cpp
            parser/parser.h parser/parser.cpp
            parser/module.h parser/module.cpp

            outputdialog.h outputdialog.cpp outputdialog.ui
            output/output_options.h output/output_options.cpp

            utils/utils.h utils/utils.cpp
            image/checkimage.h image/checkimage.cpp
            net/net.h net/net.cpp
            settings/settings.h settings/settings.cpp
            settingsdialog.h settingsdialog.cpp settingsdialog.ui
            adjustpicturedialog.h adjustpicturedialog.cpp adjustpicturedialog.ui
            image_redactor/imageredactor.h image_redactor/imageredactor.cpp
            solvecaptchadialog.h solvecaptchadialog.cpp solvecaptchadialog.ui
            exceptions/ofdrequestexception.h exceptions/ofdrequestexception.cpp
            ${QM_FILES}
        )



        # configure_file(translations.qrc ${CMAKE_BINARY_DIR} COPYONLY)
        # QT5_ADD_TRANSLATION(TRANSLATIONS ${CMAKE_SOURCE_DIR} translations/en_US.ts)
    endif()
endif()

target_link_libraries(checks-parser PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)

# Qt for iOS sets MACOSX_BUNDLE_GUI_IDENTIFIER automatically since Qt 6.1.
# If you are developing for iOS or macOS you should consider setting an
# explicit, fixed bundle identifier manually though.
if(${QT_VERSION} VERSION_LESS 6.1.0)
  set(BUNDLE_ID_OPTION MACOSX_BUNDLE_GUI_IDENTIFIER com.example.checks-parser)
endif()
set_target_properties(checks-parser PROPERTIES
    ${BUNDLE_ID_OPTION}
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

include(GNUInstallDirs)
install(TARGETS checks-parser
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

if(QT_VERSION_MAJOR EQUAL 6)
    qt_finalize_executable(checks-parser)
endif()

find_package(OpenCV REQUIRED)

include_directories( ${OpenCV_INCLUDE_DIRS} )
target_link_libraries(checks-parser PRIVATE -lzbar)
target_link_libraries(checks-parser PRIVATE -ltesseract)
target_link_libraries(checks-parser PRIVATE -lcurl)
target_link_libraries(checks-parser PRIVATE ${OpenCV_LIBS} )
if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8)
target_link_libraries(checks-parser PRIVATE -lstdc++fs)
endif()
